#ifndef ECORE_PARENT_EO_HH
#define ECORE_PARENT_EO_HH
#include <Eo.h>

extern "C" {
#include "ecore_parent.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace ecore { 
struct Parent;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::ecore::Parent> : ::std::true_type {}; } }

namespace eo_cxx {
namespace ecore { 
struct Parent {
   static Eo_Class const* _eo_class()
   {
      return ECORE_PARENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::ecore::Parent() const;
   operator ::ecore::Parent&();
   operator ::ecore::Parent const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Parent,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Parent const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace ecore { 
struct Parent : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Parent( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Parent(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Parent(Parent const& other) = default;
   Parent(Parent&& other) = default;
   Parent& operator=(Parent const& other) = default;
   Parent& operator=(Parent&& other) = default;
   Parent()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Parent( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Parent(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ECORE_PARENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Parent,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Parent const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Parent) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Parent>::value, "");
} 
#include "ecore_parent.eo.impl.hh"
#endif
